diff --git a/runtime/queue.c b/runtime/queue.c
index 0998b6ee07..7b1f9bc4de 100644
--- a/runtime/queue.c
+++ b/runtime/queue.c
@@ -450,6 +450,20 @@ StartDA(qqueue_t *pThis)
 	CHKiRet(qqueueSettoQShutdown(pThis->pqDA, pThis->toQShutdown));
 	CHKiRet(qqueueSetiHighWtrMrk(pThis->pqDA, 0));
 	CHKiRet(qqueueSetiDiscardMrk(pThis->pqDA, 0));
+	if(pThis->useCryprov) {
+		/* hand over cryprov to DA queue - in-mem queue does no longer need it
+		 * and DA queue will be kept active from now on until termination.
+		 */
+		pThis->pqDA->useCryprov = pThis->useCryprov;
+		pThis->pqDA->cryprov = pThis->cryprov;
+		pThis->pqDA->cryprovData = pThis->cryprovData;
+		pThis->pqDA->cryprovNameFull = pThis->cryprovNameFull;
+		/* reset memory queue parameters */
+		pThis->useCryprov = 0;
+		/* pThis->cryprov cannot and need not be reset, is structure */
+		pThis->cryprovData = NULL;
+		pThis->cryprovNameFull = NULL;
+	}
 
 	iRet = qqueueStart(pThis->pqDA);
 	/* file not found is expected, that means it is no previous QIF available */
diff --git a/tests/Makefile.am b/tests/Makefile.am
index 66b4a91e93..1fe652f641 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -135,6 +135,7 @@ TESTS +=  \
 	imtcp-multiport.sh \
 	imtcp_incomplete_frame_at_end.sh \
 	queue-encryption-disk.sh \
+	queue-encryption-da.sh \
 	daqueue-persist.sh \
 	daqueue-invld-qi.sh \
 	daqueue-dirty-shutdown.sh \
@@ -1432,6 +1433,7 @@ EXTRA_DIST= \
 	diag.sh \
 	rcvr_fail_restore.sh \
 	queue-encryption-disk.sh \
+	queue-encryption-da.sh \
 	daqueue-dirty-shutdown.sh \
 	daqueue-invld-qi.sh \
 	daqueue-persist.sh \
diff --git a/tests/queue-encryption-da.sh b/tests/queue-encryption-da.sh
new file mode 100755
index 0000000000..ab16ddd36a
--- /dev/null
+++ b/tests/queue-encryption-da.sh
@@ -0,0 +1,34 @@
+#!/bin/bash
+# addd 2018-09-28 by RGerhards, released under ASL 2.0
+. $srcdir/diag.sh init
+generate_conf
+add_conf '
+module(load="../plugins/omtesting/.libs/omtesting")
+global(workDirectory="'${RSYSLOG_DYNNAME}'.spool")
+main_queue(queue.filename="mainq"
+	queue.type="linkedList"
+	queue.maxDiskSpace="4m"
+	queue.maxfilesize="1m"
+	queue.timeoutenqueue="300000"
+	queue.lowwatermark="5000"
+
+	queue.cry.provider="gcry"
+	queue.cry.key="1234567890123456"
+	queue.saveonshutdown="on"
+)
+
+template(name="outfmt" type="string"
+	 string="%msg:F,58:2%,%msg:F,58:3%,%msg:F,58:4%\n")
+
+:omtesting:sleep 0 5000
+:msg, contains, "msgnum:" action(type="omfile" template="outfmt"
+			         file=`echo $RSYSLOG_OUT_LOG`)
+'
+startup
+injectmsg 0 1000
+shutdown_immediate
+wait_shutdown
+echo INFO: queue files in ${RSYSLOG_DYNNAME}.spool:
+ls -l ${RSYSLOG_DYNNAME}.spool
+check_not_present "msgnum:0000" ${RSYSLOG_DYNNAME}.spool/mainq.0*
+exit_test
